{% load panel_helpers %}

<table class="table table-bordered table-hover" id="entities_table">
    <thead class="table-light">
        <tr>
            <th class="js-sortable-header sorted-column sorted-desc w-8"
                data-sort-key="list-index"
                data-sort-type="number"
            >
                List
                <i class="fa fa-arrow-down"></i>
                <i class="fa fa-arrow-up"></i>
            </th>
            <th class="js-sortable-header w-12"
                data-sort-key="entity-name"
                data-sort-type="name"
            >
                Entity
                <i class="fa fa-arrow-down"></i>
                <i class="fa fa-arrow-up"></i>
            </th>
            <th class="js-sortable-header w-16"
                data-sort-key="reviews"
                data-sort-type="number"
            >
                Reviews
                <i class="fa fa-arrow-down"></i>
                <i class="fa fa-arrow-up"></i>
            </th>
            <th class="js-sortable-header w-18"
                data-sort-key="moi"
                data-sort-type="name"
            >
                Mode of inheritance
                <i class="fa fa-arrow-down"></i>
                <i class="fa fa-arrow-up"></i>
            </th>
            <th class="w-46">Details</th>
        </tr>
        <tr class="if-no-js-hide">
            <td colspan="100">
                <div>
                    <label for="gene-filter" class="rm">Filter Entities</label>
                    <div class="input-group">
                        <input id="gene-filter" type="text" class="form-control normal js-filter-table-input" placeholder="Filter Entities">
                        <span class="input-group-text js-filter-table-count" data-singular="Entity" data-plural="Entities">
                            {{ entities|length }} Entities{{entities|length|pluralize}}
                        </span>
                    </div>
                </div>
            </td>
        </tr>
    </thead>
    <tbody>
    {% for entry in entities %}
    <tr
        data-entity-name="{{ entry.name }}"
        data-list-index="{{ entry.status }}"
        data-moi="{{ entry.moi }}"
        data-reviews="{{ entry.number_of_evaluations }}"
    >
    <td class="text-right">
        <x-rating-badge
        rating="{{ entry.entity_color_name }}"
        {% if entry.ready and request.user.is_authenticated and request.user.reviewer.is_GEL %}ready{% endif %}
        block
        ></x-rating-badge>
        {% if not entry.ready and request.user.is_authenticated and request.user.reviewer.is_GEL %}
            <span class="rm">Not ready</span>
        {% endif %}
        <span class="rm">{{ entry.gene_list_name }}</span>
        {% if not panel.is_super_panel and request.user.is_authenticated and request.user.reviewer.is_GEL %}
        <div class="add-top-margin">
            <a
                href="#lock_{{ entry.name|remove_special }}"
                class="btn btn-outline-light-panelapp btn-sm text-primary lock_{{ entry.name|remove_special }} d-none"
                data-module="showhide"
                data-show="a.btn.unlock_{{ entry.name|remove_special }}"
                data-hide="a.lock_{{ entry.name|remove_special }}, a.btn.delete_entity_{{ entry.name|remove_special }}, a.delete_source_{{ entry.name|remove_special }}"
                data-testid="lock-entity-{{ entry.name|remove_special }}"
            >
                <i class="fa fa-lock fa-lg"></i>
            </a>
            <a
                href="#unlock_{{ entry.name|remove_special }}"
                class="btn btn-outline-light-panelapp btn-sm text-primary unlock_{{ entry.name|remove_special }}"
                data-module="showhide"
                data-show="a.btn.lock_{{ entry.name|remove_special }}, a.delete_entity_{{ entry.name|remove_special }}, a.delete_source_{{ entry.name|remove_special }}"
                data-hide="a.btn.unlock_{{ entry.name|remove_special }}"
                data-testid="unlock-entity-{{ entry.name|remove_special }}"
            >
                <i class="fa fa-unlock fa-lg"></i>
            </a>
            <a
                href="{% url 'panels:delete_entity' panel.panel_id entry.entity_type entry.name %}"
                class="btn btn-outline-light-panelapp btn-sm text-primary d-none delete_entity_{{ entry.name|remove_special }}"
                data-ajax="true"
                data-success="djangoAjaxHandler"
                data-testid="delete-entity-{{ entry.name|remove_special }}"
            >
                <i class="fa fa-trash fa-lg"></i>
            </a>
            {% if entry.flagged %}
            <a
                href="{% url 'panels:approve_entity' panel.panel_id entry.entity_type entry.name %}"
                data-ajax="true"
                data-success="djangoAjaxHandler"
                data-testid="approve-entity-{{ entry.name|remove_special }}"
            >
                <i class="fa fa-plus fa-lg"></i>
            </a>
            {% endif %}
        </div>
        {% endif %}
    </td>
    <td>
        <h5 class="gene-cell-title">
            <a href="{{ entry.get_absolute_url }}" class="link-inherit gel-text {{ entry.gene_list_class }} js-open-on-submit">
                {% if entry.entity_type == 'region' %}{{ entry.verbose_name }}{% else %}{{ entry.name }}{% endif %}
            </a>
        </h5>
        {% if entry.entity_type == 'str' %}
            <span class="label label-default">STR</span>
        {% elif entry.entity_type == 'region' %}
            {{ entry.name }}<br />
            <span class="label label-default">Region</span>
        {% endif %}
        {% if is_super_panel %}
            <div><a class="text-muted small" href="{{ entry.panel.get_absolute_url }}">{{ entry.panel }}</a></div>
        {% endif %}
    </td>
    <td>
        {% with evaluation_count=entry.number_of_evaluations %}
            <h5 class="normal gene-cell-title add-label-margin text-muted">{{ evaluation_count }} review{{evaluation_count|pluralize}}</h5>
            {% if request.user.is_authenticated %}
            {% if request.user.pk in entry.evaluators %}
                <div class="text-muted add-bottom-margin"><i class="fa fa-check"></i> You reviewed</div>
            {% elif request.user.is_authenticated and request.user.reviewer.is_verified %}
                <div class="text-muted add-bottom-margin">
                    <a href="{{ entry.get_absolute_url }}" class="link-muted">Add review</a>
                </div>
            {% endif %}
            {% endif %}
            {% if evaluation_count > 0 %}
            {% if entry.number_of_green_evaluations > 0 %}
            <span class="add-right-margin gel-text gel-green">
                {{ entry.number_of_green_evaluations }} green
            </span>
            {% endif %}
            {% if entry.number_of_red_evaluations > 0 %}
            <span class="add-right-margin gel-text gel-red">
                {{ entry.number_of_red_evaluations }} red
            </span>
            {% endif %}
            {% endif %}
        {% endwith %}
    </td>
    <td>
        {% if entry.moi %}
        {{ entry.moi }}
        {% else %}
        Not set
        {% endif %}
    </td>
    <td class="fs-7">

        {% if entry.entity_evidences %}
        <h6 class="add-label-margin remove-top-margin">Sources</h6>
        <ul>
            {% for ev in entry.entity_evidences %}
                {% if ev %}
                <li>
                    {{ ev }}

                    {% if not panel.is_super_panel and request.user.is_authenticated and request.user.reviewer.is_GEL %}
                    <a
                        href="#"
                        class="d-none delete_source_{{ entry.name|remove_special }}"
                        hx-get="{% url 'panels:clear_entity_source_for_entity_list' panel.panel_id entry.entity_type entry.name ev %}"
                        hx-target="#entities_table"
                        hx-swap="outerHTML"
                    >
                        <i class="fa fa-times-circle"></i>
                    </a>
                    {% endif %}
                </li>
                {% endif %}
            {% endfor %}
        </ul>
        {% endif %}
        {% if entry.phenotypes and entry.phenotypes.0 %}
            <h6 class="add-label-margin">Phenotypes</h6>
            <ul>
                {% for phenotype in entry.phenotypes %}
                <li class="word-break">{{ phenotype }}</li>
                {% endfor %}
            </ul>
        {% endif %}

        {% if entry.entity_tags %}
            <h6 class="add-label-margin">Tags</h6>
            <ul class="list-inline tag-list">
                {% for tag in entry.entity_tags %}
                    {% if tag %}
                    <li class="list-inline-item border rounded border-1 px-1 fs-7">{{ tag }}</li>
                    {% endif %}
                {% endfor %}
            </ul>
        {% endif %}
    </td>
    </tr>
    {% endfor %}
    </tbody>
    {% if not panel.is_super_panel and request.user.is_authenticated and request.user.reviewer.is_verified %}
    <tfoot class="table-light">
        <tr>
            <td colspan="100">
                <a href="{% url 'panels:add_entity' panel.panel_id 'gene' %}" class="btn btn-outline-light-panelapp btn-large">
                    <i class="fa fa-plus add-right-margin"></i> Add a Gene to this panel
                </a>

                <a href="{% url 'panels:add_entity' panel.panel_id 'str' %}" class="btn btn-large btn-outline-light-panelapp">
                    <i class="fa fa-plus add-right-margin"></i> Add a STR to this panel
                </a>

                <a href="{% url 'panels:add_entity' panel.panel_id 'region' %}" class="btn btn-large btn-outline-light-panelapp">
                    <i class="fa fa-plus add-right-margin"></i> Add a Region to this panel
                </a>
            </td>
        </tr>
    </tfoot>
    {% endif %}
</table>
